class ListaConcatenata {
	// METODO ATTRAVERSAMENTO COME ARRAY
	public void Attraversamento (int[] info, int[] link) {
		System.out.println("i info link");
      for (int i=0; i<info.length; i++) {
			System.out.println(i + " " + info[i] + "  " + link[i]);
      }
	} 
	
	// METODO ATTRAVERSAMENTO INFO COME LISTA CONCATENATA
	public void AttraversamentoI (int[] info, int[] link) { 
      int inizio 		 = info[0];		
      int disponibile = link[0];		
      int ptr 			 = inizio;
		System.out.println("i info link");
      while(ptr != -1) {
			System.out.println(ptr + " " + info[ptr] + "  " + link[ptr]);
      	ptr = link[ptr];
      }
	} 
  
	// METODO ATTRAVERSAMENTO DISPONIBILE COME LISTA CONCATENATA
	public void AttraversamentoD (int[] info, int[] link) { 
      int inizio 		 = info[0];		
      int disponibile = link[0];		
      int ptr			 = disponibile;
		System.out.println("i info link");
      while(ptr != -1) {
			System.out.println(ptr + " " + info[ptr] + "    " + link[ptr]);
      	ptr = link[ptr];
      }
	} 
	
	// METODO RICERCA ITEM IN INFO COME LISTA CONCATENATA
	static int Ricerca (int[] info, int[] link, int item) { 
      int inizio 		 = info[0];		
      int disponibile = link[0];		
      int ptr = inizio;
		int loc = 0;
      while(ptr != -1) {
			if (info[ptr] == item){ 
				// TROVATO
				loc = ptr;
				break;
			}				
			else {
				//PTR punta ora al nodo successivo				
				ptr = link[ptr];  
			}
      }
		return loc;
	} 
	
	// METODO RICERCA ITEM IN INFO COME LISTA CONCATENATA ORDINATA
	static int RicercaOrd (int[] info, int[] link, int item) { 
      int inizio 		 = info[0];		
      int disponibile = link[0];		
      int ptr = inizio;
		int loc = 0;
      while(ptr != -1) {
			if (info[ptr] < item){ 
				//PTR punta ora al nodo successivo				
				ptr = link[ptr];  
			}				
			else {
				if (info[ptr] == item){ 
					// TROVATO
					loc = ptr;
				}				
				break;				
			}
      }
		return loc;
	} 
		
	// METODO RICERCA LOC per ins IN INFO COME LISTA CONCATENATA ORDINATA
	static int RicercaLocOrd (int[] info, int[] link, int item) { 
      int inizio 	  = info[0];		
      int disponibile = link[0];		
      int ptr = inizio;
	  int loc = 0;
	  int SAVE = inizio; ptr = link[inizio];
      while(ptr != -1) {
			if (info[ptr] > item){ 
				loc = SAVE; 
				break;
			}				
            SAVE = ptr; ptr = link[ptr];
	  } 
	  loc = SAVE; 
	    return loc;
	}
	
	// METODO INSERIMENTO ITEM INIZIO LISTA CONCATENATA
	static int InserimentoInizio (int[] info, int[] link, int item) { 
		int risultato 	 = 0;		
      int inizio 		 = info[0];		
      int disponibile = link[0];
		
		if (disponibile == -1) { 
			// Nessuna disponibilita
			risultato = -1;
		}
		else {
			// Toglie il primo nodo da lista disponibili
			int nuovo = disponibile; 
			disponibile = link[disponibile]; 
			// Copia il nuovo dato in nuovo nodo 
			info[nuovo] = item; 
			// Il nuovo nodo punta ora al primo
			link[nuovo] = inizio;
			// Cambia START in modo che punti al nuovo nodo
			inizio = nuovo;	
			//System.out.println("Nuovo inizio" + inizio);
			//System.out.println("Nuovo disponibile" + disponibile);
			info[0] = inizio;
			link[0] = disponibile;
			risultato = 1;
		}
		return risultato;
	} 
	
	// METODO INSERIMENTO ITEM IN LISTA CONCATENATA DOPO loc
	static int Inserimento (int[] info, int[] link, int item, int loc) { 
		int risultato = 0;		
      int inizio 		 = info[0];		
      int disponibile = link[0];

		if (disponibile == -1) { 
			// Nessuna disponibilita
			risultato = -1;
		}
		else {
			// Toglie il primo nodo da lista disponibili
			int nuovo = disponibile; 
			disponibile = link[disponibile]; 
			// Copia il nuovo dato in nuovo nodo 
			info[nuovo] = item; 
			if (loc == 0) {
				// Il nuovo nodo punta ora al primo
				link[nuovo] = inizio;
				// Cambia inizio in modo che punti al nuovo nodo
				inizio = nuovo;
				risultato = 1;
			}
			else {
				//Inserisce dopo nodo con locazione loc. 
				link[nuovo] = link[loc];
				link[loc] = nuovo;
				risultato = loc;
			}  
			info[0] = inizio;
			link[0] = disponibile;
		}
		return risultato;
	} 
}
